% Copyright October, 2005, Brown University, Providence, RI. 
% All Rights Reserved 

% Permission to use, copy, modify, and distribute this software and its
% documentation for any purpose other than its incorporation into a commercial
% product is hereby granted without fee, provided that the above copyright
% notice appear in all copies and that both that copyright notice and this
% permission notice appear in supporting documentation, and that the name of
% Brown University not be used in advertising or publicity pertaining to
% distribution of the software without specific, written prior permission. 

% BROWN UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
% INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
% PARTICULAR PURPOSE. IN NO EVENT SHALL BROWN UNIVERSITY BE LIABLE FOR ANY
% SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
% RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
% CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
% CONNECTION WITH THE USE.

% Author: Frank Wood fwood@cs.brown.edu.

function plot_fisher_projection(training_data,w_opt,b,P_gamma_given_Z,fig_num)

rate = training_data.concat_rate;
num_points = size(rate,1);
figure(fig_num);
[bin_counts,bins] = hist(rate*w_opt,100);
fscale = diff(bins);
fscale = fscale(1);
fscale = 1;%1/fscale;
% hist(rate*w_opt,100);
clf;
hold on;
hist(rate(find(training_data.true_label==-1),:)*w_opt,bins);
h = findobj(gca,'Type','patch');
set(h,'FaceColor','r','EdgeColor','w')
scale = P_gamma_given_Z.go_alpha*fscale;
l1h = plot_1d_gaussian(P_gamma_given_Z.go_mean,P_gamma_given_Z.go_var,bins,scale,'r');
hist(rate(find(training_data.true_label==1),:)*w_opt,bins);

scale = P_gamma_given_Z.stop_alpha*fscale;
l2h = plot_1d_gaussian(P_gamma_given_Z.stop_mean,P_gamma_given_Z.stop_var,bins,scale,'b');

h=line([b b],[0 max(bin_counts)]);
set(h,'Color',[.2 1 .2]);
hold off;
legend([h l1h l2h],'b','Go', 'Stop');
title('Histogram of neural activity history projected on Fisher linear separator');
